Index: roard/codecfilter_alaw.c
===================================================================
--- roard/codecfilter_alaw.c	(revision 3604)
+++ roard/codecfilter_alaw.c	(revision 3811)
@@ -2,5 +2,5 @@
 
 /*
- *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2008
+ *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2008-2010
  *
  *  This file is part of roard a part of RoarAudio,
Index: roard/codecfilter_celt.c
===================================================================
--- roard/codecfilter_celt.c	(revision 3517)
+++ roard/codecfilter_celt.c	(revision 3811)
@@ -2,5 +2,5 @@
 
 /*
- *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2008
+ *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2008-2010
  *
  *  This file is part of roard a part of RoarAudio,
Index: roard/codecfilter_cmd.c
===================================================================
--- roard/codecfilter_cmd.c	(revision 3517)
+++ roard/codecfilter_cmd.c	(revision 3811)
@@ -2,5 +2,5 @@
 
 /*
- *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2008
+ *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2008-2010
  *
  *  This file is part of roard a part of RoarAudio,
Index: roard/codecfilter_fishsound.c
===================================================================
--- roard/codecfilter_fishsound.c	(revision 3764)
+++ roard/codecfilter_fishsound.c	(revision 3811)
@@ -2,5 +2,5 @@
 
 /*
- *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2008
+ *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2008-2010
  *
  *  This file is part of roard a part of RoarAudio,
Index: roard/codecfilter_mulaw.c
===================================================================
--- roard/codecfilter_mulaw.c	(revision 3517)
+++ roard/codecfilter_mulaw.c	(revision 3811)
@@ -2,5 +2,5 @@
 
 /*
- *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2008
+ *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2008-2010
  *
  *  This file is part of roard a part of RoarAudio,
Index: roard/codecfilter_raum.c
===================================================================
--- roard/codecfilter_raum.c	(revision 3517)
+++ roard/codecfilter_raum.c	(revision 3811)
@@ -2,5 +2,5 @@
 
 /*
- *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2009
+ *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2009-2010
  *
  *  This file is part of roard a part of RoarAudio,
Index: roard/codecfilter_sndfile.c
===================================================================
--- roard/codecfilter_sndfile.c	(revision 3517)
+++ roard/codecfilter_sndfile.c	(revision 3811)
@@ -2,5 +2,5 @@
 
 /*
- *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2008
+ *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2008-2010
  *
  *  This file is part of roard a part of RoarAudio,
Index: roard/codecfilter_speex.c
===================================================================
--- roard/codecfilter_speex.c	(revision 3517)
+++ roard/codecfilter_speex.c	(revision 3811)
@@ -2,5 +2,5 @@
 
 /*
- *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2008
+ *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2008-2010
  *
  *  This file is part of roard a part of RoarAudio,
Index: roard/codecfilter_vorbis.c
===================================================================
--- roard/codecfilter_vorbis.c	(revision 3517)
+++ roard/codecfilter_vorbis.c	(revision 3811)
@@ -2,5 +2,5 @@
 
 /*
- *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2008
+ *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2008-2010
  *
  *  This file is part of roard a part of RoarAudio,
Index: roard/commands.c
===================================================================
--- roard/commands.c	(revision 3574)
+++ roard/commands.c	(revision 3811)
@@ -2,5 +2,5 @@
 
 /*
- *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2008
+ *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2008-2010
  *
  *  This file is part of roard a part of RoarAudio,
Index: roard/container_framework.c
===================================================================
--- roard/container_framework.c	(revision 3517)
+++ roard/container_framework.c	(revision 3811)
@@ -2,5 +2,5 @@
 
 /*
- *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2009
+ *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2009-2010
  *
  *  This file is part of roard a part of RoarAudio,
Index: roard/driver_dmx.c
===================================================================
--- roard/driver_dmx.c	(revision 3517)
+++ roard/driver_dmx.c	(revision 3811)
@@ -2,5 +2,5 @@
 
 /*
- *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2009
+ *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2009-2010
  *
  *  This file is part of roard a part of RoarAudio,
Index: roard/driver_pwmled.c
===================================================================
--- roard/driver_pwmled.c	(revision 3602)
+++ roard/driver_pwmled.c	(revision 3811)
@@ -2,5 +2,5 @@
 
 /*
- *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2009
+ *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2009-2010
  *
  *  This file is part of roard a part of RoarAudio,
Index: roard/driver_sndio.c
===================================================================
--- roard/driver_sndio.c	(revision 3517)
+++ roard/driver_sndio.c	(revision 3811)
@@ -2,5 +2,5 @@
 
 /*
- *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2009
+ *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2009-2010
  *
  *  This file is part of roard a part of RoarAudio,
Index: roard/driver_sysclock.c
===================================================================
--- roard/driver_sysclock.c	(revision 3517)
+++ roard/driver_sysclock.c	(revision 3811)
@@ -2,5 +2,5 @@
 
 /*
- *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2008
+ *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2008-2010
  *
  *  This file is part of roard a part of RoarAudio,
Index: roard/driver_wmm.c
===================================================================
--- roard/driver_wmm.c	(revision 3517)
+++ roard/driver_wmm.c	(revision 3811)
@@ -2,5 +2,5 @@
 
 /*
- *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2009
+ *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2009-2010
  *
  *  This file is part of roard a part of RoarAudio,
Index: roard/include/client.h
===================================================================
--- roard/include/client.h	(revision 3737)
+++ roard/include/client.h	(revision 3811)
@@ -2,5 +2,5 @@
 
 /*
- *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2008
+ *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2008-2010
  *
  *  This file is part of roard a part of RoarAudio,
Index: roard/include/codecfilter.h
===================================================================
--- roard/include/codecfilter.h	(revision 3604)
+++ roard/include/codecfilter.h	(revision 3811)
@@ -2,5 +2,5 @@
 
 /*
- *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2008
+ *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2008-2010
  *
  *  This file is part of roard a part of RoarAudio,
Index: roard/include/codecfilter_celt.h
===================================================================
--- roard/include/codecfilter_celt.h	(revision 3517)
+++ roard/include/codecfilter_celt.h	(revision 3811)
@@ -2,5 +2,5 @@
 
 /*
- *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2008
+ *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2008-2010
  *
  *  This file is part of roard a part of RoarAudio,
Index: roard/include/codecfilter_cmd.h
===================================================================
--- roard/include/codecfilter_cmd.h	(revision 3517)
+++ roard/include/codecfilter_cmd.h	(revision 3811)
@@ -2,5 +2,5 @@
 
 /*
- *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2008
+ *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2008-2010
  *
  *  This file is part of roard a part of RoarAudio,
Index: roard/include/codecfilter_fishsound.h
===================================================================
--- roard/include/codecfilter_fishsound.h	(revision 3517)
+++ roard/include/codecfilter_fishsound.h	(revision 3811)
@@ -2,5 +2,5 @@
 
 /*
- *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2008
+ *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2008-2010
  *
  *  This file is part of roard a part of RoarAudio,
Index: roard/include/codecfilter_sndfile.h
===================================================================
--- roard/include/codecfilter_sndfile.h	(revision 3517)
+++ roard/include/codecfilter_sndfile.h	(revision 3811)
@@ -2,5 +2,5 @@
 
 /*
- *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2008
+ *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2008-2010
  *
  *  This file is part of roard a part of RoarAudio,
Index: roard/include/codecfilter_speex.h
===================================================================
--- roard/include/codecfilter_speex.h	(revision 3517)
+++ roard/include/codecfilter_speex.h	(revision 3811)
@@ -2,5 +2,5 @@
 
 /*
- *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2008
+ *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2008-2010
  *
  *  This file is part of roard a part of RoarAudio,
Index: roard/include/codecfilter_vorbis.h
===================================================================
--- roard/include/codecfilter_vorbis.h	(revision 3517)
+++ roard/include/codecfilter_vorbis.h	(revision 3811)
@@ -2,5 +2,5 @@
 
 /*
- *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2008
+ *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2008-2010
  *
  *  This file is part of roard a part of RoarAudio,
Index: roard/include/codecfilter_wave.h
===================================================================
--- roard/include/codecfilter_wave.h	(revision 3686)
+++ roard/include/codecfilter_wave.h	(revision 3811)
@@ -2,5 +2,5 @@
 
 /*
- *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2008
+ *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2008-2010
  *
  *  This file is part of roard a part of RoarAudio,
Index: roard/include/commands.h
===================================================================
--- roard/include/commands.h	(revision 3517)
+++ roard/include/commands.h	(revision 3811)
@@ -2,5 +2,5 @@
 
 /*
- *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2008
+ *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2008-2010
  *
  *  This file is part of roard a part of RoarAudio,
Index: roard/include/container_framework.h
===================================================================
--- roard/include/container_framework.h	(revision 3517)
+++ roard/include/container_framework.h	(revision 3811)
@@ -2,5 +2,5 @@
 
 /*
- *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2009
+ *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2009-2010
  *
  *  This file is part of roard a part of RoarAudio,
Index: roard/include/driver.h
===================================================================
--- roard/include/driver.h	(revision 3751)
+++ roard/include/driver.h	(revision 3811)
@@ -2,5 +2,5 @@
 
 /*
- *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2008
+ *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2008-2010
  *
  *  This file is part of roard a part of RoarAudio,
Index: roard/include/driver_ao.h
===================================================================
--- roard/include/driver_ao.h	(revision 3588)
+++ roard/include/driver_ao.h	(revision 3811)
@@ -2,5 +2,5 @@
 
 /*
- *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2008
+ *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2008-2010
  *
  *  This file is part of roard a part of RoarAudio,
Index: roard/include/driver_dmx.h
===================================================================
--- roard/include/driver_dmx.h	(revision 3517)
+++ roard/include/driver_dmx.h	(revision 3811)
@@ -2,5 +2,5 @@
 
 /*
- *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2009
+ *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2009-2010
  *
  *  This file is part of roard a part of RoarAudio,
Index: roard/include/driver_esd.h
===================================================================
--- roard/include/driver_esd.h	(revision 3591)
+++ roard/include/driver_esd.h	(revision 3811)
@@ -2,5 +2,5 @@
 
 /*
- *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2008
+ *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2008-2010
  *
  *  This file is part of roard a part of RoarAudio,
Index: roard/include/driver_oss.h
===================================================================
--- roard/include/driver_oss.h	(revision 3517)
+++ roard/include/driver_oss.h	(revision 3811)
@@ -2,5 +2,5 @@
 
 /*
- *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2008
+ *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2008-2010
  *
  *  This file is part of roard a part of RoarAudio,
Index: roard/include/driver_pwmled.h
===================================================================
--- roard/include/driver_pwmled.h	(revision 3517)
+++ roard/include/driver_pwmled.h	(revision 3811)
@@ -2,5 +2,5 @@
 
 /*
- *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2009
+ *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2009-2010
  *
  *  This file is part of roard a part of RoarAudio,
Index: roard/include/driver_raw.h
===================================================================
--- roard/include/driver_raw.h	(revision 3517)
+++ roard/include/driver_raw.h	(revision 3811)
@@ -2,5 +2,5 @@
 
 /*
- *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2008
+ *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2008-2010
  *
  *  This file is part of roard a part of RoarAudio,
Index: roard/include/driver_roar.h
===================================================================
--- roard/include/driver_roar.h	(revision 3593)
+++ roard/include/driver_roar.h	(revision 3811)
@@ -2,5 +2,5 @@
 
 /*
- *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2008
+ *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2008-2010
  *
  *  This file is part of roard a part of RoarAudio,
Index: roard/include/driver_shout.h
===================================================================
--- roard/include/driver_shout.h	(revision 3589)
+++ roard/include/driver_shout.h	(revision 3811)
@@ -2,5 +2,5 @@
 
 /*
- *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2008
+ *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2008-2010
  *
  *  This file is part of roard a part of RoarAudio,
Index: roard/include/driver_sndio.h
===================================================================
--- roard/include/driver_sndio.h	(revision 3517)
+++ roard/include/driver_sndio.h	(revision 3811)
@@ -2,5 +2,5 @@
 
 /*
- *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2009
+ *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2009-2010
  *
  *  This file is part of roard a part of RoarAudio,
Index: roard/include/driver_sysclock.h
===================================================================
--- roard/include/driver_sysclock.h	(revision 3517)
+++ roard/include/driver_sysclock.h	(revision 3811)
@@ -2,5 +2,5 @@
 
 /*
- *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2008
+ *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2008-2010
  *
  *  This file is part of roard a part of RoarAudio,
Index: roard/include/driver_wmm.h
===================================================================
--- roard/include/driver_wmm.h	(revision 3517)
+++ roard/include/driver_wmm.h	(revision 3811)
@@ -2,5 +2,5 @@
 
 /*
- *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2009
+ *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2009-2010
  *
  *  This file is part of roard a part of RoarAudio,
Index: roard/include/emul_esd.h.OLD
===================================================================
--- roard/include/emul_esd.h.OLD	(revision 3517)
+++ roard/include/emul_esd.h.OLD	(revision 3811)
@@ -2,5 +2,5 @@
 
 /*
- *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2009
+ *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2009-2010
  *
  *  This file is part of roard a part of RoarAudio,
Index: roard/include/lib.h
===================================================================
--- roard/include/lib.h	(revision 3517)
+++ roard/include/lib.h	(revision 3811)
@@ -2,5 +2,5 @@
 
 /*
- *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2008
+ *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2008-2010
  *
  *  This file is part of roard a part of RoarAudio,
Index: roard/include/light.h
===================================================================
--- roard/include/light.h	(revision 3517)
+++ roard/include/light.h	(revision 3811)
@@ -2,5 +2,5 @@
 
 /*
- *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2008
+ *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2008-2010
  *
  *  This file is part of roard a part of RoarAudio,
Index: roard/include/meta.h
===================================================================
--- roard/include/meta.h	(revision 3517)
+++ roard/include/meta.h	(revision 3811)
@@ -2,5 +2,5 @@
 
 /*
- *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2008
+ *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2008-2010
  *
  *  This file is part of roard a part of RoarAudio,
Index: roard/include/midi.h
===================================================================
--- roard/include/midi.h	(revision 3517)
+++ roard/include/midi.h	(revision 3811)
@@ -2,5 +2,5 @@
 
 /*
- *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2008
+ *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2008-2010
  *
  *  This file is part of roard a part of RoarAudio,
Index: roard/include/mixer.h
===================================================================
--- roard/include/mixer.h	(revision 3517)
+++ roard/include/mixer.h	(revision 3811)
@@ -2,5 +2,5 @@
 
 /*
- *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2008
+ *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2008-2010
  *
  *  This file is part of roard a part of RoarAudio,
Index: roard/include/network.h
===================================================================
--- roard/include/network.h	(revision 3517)
+++ roard/include/network.h	(revision 3811)
@@ -2,5 +2,5 @@
 
 /*
- *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2008
+ *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2008-2010
  *
  *  This file is part of roard a part of RoarAudio,
Index: roard/include/output.h
===================================================================
--- roard/include/output.h	(revision 3517)
+++ roard/include/output.h	(revision 3811)
@@ -2,5 +2,5 @@
 
 /*
- *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2008
+ *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2008-2010
  *
  *  This file is part of roard a part of RoarAudio,
Index: roard/include/raw.h
===================================================================
--- roard/include/raw.h	(revision 3517)
+++ roard/include/raw.h	(revision 3811)
@@ -2,5 +2,5 @@
 
 /*
- *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2009
+ *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2009-2010
  *
  *  This file is part of roard a part of RoarAudio,
Index: roard/include/rdtcs.h
===================================================================
--- roard/include/rdtcs.h	(revision 3517)
+++ roard/include/rdtcs.h	(revision 3811)
@@ -2,5 +2,5 @@
 
 /*
- *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2009
+ *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2009-2010
  *
  *  This file is part of roard a part of RoarAudio,
Index: roard/include/req.h
===================================================================
--- roard/include/req.h	(revision 3574)
+++ roard/include/req.h	(revision 3811)
@@ -2,5 +2,5 @@
 
 /*
- *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2008
+ *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2008-2010
  *
  *  This file is part of roard a part of RoarAudio,
Index: roard/include/sample.h
===================================================================
--- roard/include/sample.h	(revision 3517)
+++ roard/include/sample.h	(revision 3811)
@@ -2,5 +2,5 @@
 
 /*
- *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2008
+ *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2008-2010
  *
  *  This file is part of roard a part of RoarAudio,
Index: roard/include/sources.h
===================================================================
--- roard/include/sources.h	(revision 3517)
+++ roard/include/sources.h	(revision 3811)
@@ -2,5 +2,5 @@
 
 /*
- *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2008
+ *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2008-2010
  *
  *  This file is part of roard a part of RoarAudio,
Index: roard/include/ssynth.h
===================================================================
--- roard/include/ssynth.h	(revision 3517)
+++ roard/include/ssynth.h	(revision 3811)
@@ -2,5 +2,5 @@
 
 /*
- *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2009
+ *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2009-2010
  *
  *  This file is part of roard a part of RoarAudio,
Index: roard/include/streams.h
===================================================================
--- roard/include/streams.h	(revision 3630)
+++ roard/include/streams.h	(revision 3811)
@@ -2,5 +2,5 @@
 
 /*
- *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2008
+ *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2008-2010
  *
  *  This file is part of roard a part of RoarAudio,
Index: roard/include/waveform.h
===================================================================
--- roard/include/waveform.h	(revision 3517)
+++ roard/include/waveform.h	(revision 3811)
@@ -2,5 +2,5 @@
 
 /*
- *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2009
+ *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2009-2010
  *
  *  This file is part of roard a part of RoarAudio,
Index: roard/meta.c
===================================================================
--- roard/meta.c	(revision 3517)
+++ roard/meta.c	(revision 3811)
@@ -2,5 +2,5 @@
 
 /*
- *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2008
+ *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2008-2010
  *
  *  This file is part of roard a part of RoarAudio,
Index: roard/output.c
===================================================================
--- roard/output.c	(revision 3517)
+++ roard/output.c	(revision 3811)
@@ -2,5 +2,5 @@
 
 /*
- *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2008
+ *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2008-2010
  *
  *  This file is part of roard a part of RoarAudio,
Index: roard/raw.c
===================================================================
--- roard/raw.c	(revision 3764)
+++ roard/raw.c	(revision 3811)
@@ -2,5 +2,5 @@
 
 /*
- *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2009
+ *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2009-2010
  *
  *  This file is part of roard a part of RoarAudio,
Index: roard/rdtcs.c
===================================================================
--- roard/rdtcs.c	(revision 3517)
+++ roard/rdtcs.c	(revision 3811)
@@ -2,5 +2,5 @@
 
 /*
- *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2009
+ *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2009-2010
  *
  *  This file is part of roard a part of RoarAudio,
Index: roard/sample.c
===================================================================
--- roard/sample.c	(revision 3517)
+++ roard/sample.c	(revision 3811)
@@ -2,5 +2,5 @@
 
 /*
- *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2008
+ *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2008-2010
  *
  *  This file is part of roard a part of RoarAudio,
Index: roard/signals.c
===================================================================
--- roard/signals.c	(revision 3517)
+++ roard/signals.c	(revision 3811)
@@ -2,5 +2,5 @@
 
 /*
- *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2008
+ *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2008-2010
  *
  *  This file is part of roard a part of RoarAudio,
Index: roard/sources.c
===================================================================
--- roard/sources.c	(revision 3517)
+++ roard/sources.c	(revision 3811)
@@ -2,5 +2,5 @@
 
 /*
- *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2008
+ *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2008-2010
  *
  *  This file is part of roard a part of RoarAudio,
Index: roard/ssynth.c
===================================================================
--- roard/ssynth.c	(revision 3517)
+++ roard/ssynth.c	(revision 3811)
@@ -2,5 +2,5 @@
 
 /*
- *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2009
+ *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2009-2010
  *
  *  This file is part of roard a part of RoarAudio,
Index: roard/waveform.c
===================================================================
--- roard/waveform.c	(revision 3558)
+++ roard/waveform.c	(revision 3811)
@@ -2,5 +2,5 @@
 
 /*
- *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2009
+ *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2009-2010
  *
  *  This file is part of roard a part of RoarAudio,